﻿@page "/players/create"
@page "/players/edit/{Id:int}"

@using Models.PlayerData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject IPlayerRepository PlayerRepository
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">@Title Player</h3>
    <div class="col-md-12">
        <div class="card">
            <div class="card-body">
                <EditForm Model="@PlayerModel" OnValidSubmit="HandleCreateUpdate">
                    <DataAnnotationsValidator />
                    @*<ValidationSummary />*@
                    <div class="form-group">
                        <label>Sport</label>
                        <InputText @bind-Value="currentSport" class="form-control" disabled="true"></InputText>
                    </div>
                    <div class="form-group">
                        <label>Name</label>
                        <InputText @bind-Value="PlayerModel.Name" class="form-control"></InputText>
                        <ValidationMessage For="() => PlayerModel.Name" />
                    </div>
                    <div class="form-group">
                        <label>Surname</label>
                        <InputText @bind-Value="PlayerModel.Surname" class="form-control"></InputText>
                        <ValidationMessage For="() => PlayerModel.Surname" />
                    </div>
                    <div class="form-group">
                        <button class="btn btn-primary">@Title Player</button>
                        <NavLink href="players" class="btn btn-secondary">Back to Index</NavLink>
                    </div>
                </EditForm>
            </div>
        </div>
    </div>
</div>



@code {

    [Parameter]
    public int? Id { get; set; }
    private PlayerDTO PlayerModel { get; set; } = new PlayerDTO();
    private string Title { get; set; } = "Create";
    private string currentSport { get; set; }
    protected override async Task OnInitializedAsync()
    {
        currentSport = await localStorage.GetItemAsync<string>("sportName");
        if (Id != null)
        {
            //update
            Title = "Update";
            PlayerModel = await PlayerRepository.Get(Id.Value);
        }
        else
        {
            //create
            PlayerModel = new PlayerDTO();
        }
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            // add check if player is unique
            // --
            // --
            if (PlayerModel.Id != 0 && Title == "Update")
            {
                //update
                var updatePlayer = await PlayerRepository.Update(PlayerModel, PlayerModel.Id);
                await JsRuntime.ToastrSuccess("Player updated successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/players", true);

            }
            else
            {
                //create
                PlayerModel.SportId = await localStorage.GetItemAsync<int>("sportId");
                var createdResult = await PlayerRepository.Create(PlayerModel);

                await JsRuntime.ToastrSuccess("Player created successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("/players", true);
            }
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
}
